define(["amber/boot"
//>>excludeStart("imports", pragmas.excludeImports);
, "trapped/Trapped-Processors"
//>>excludeEnd("imports");
, "amber_core/Kernel-Objects"], function($boot
//>>excludeStart("imports", pragmas.excludeImports);

//>>excludeEnd("imports");
){"use strict";
if(!$boot.nilAsReceiver)$boot.nilAsReceiver=$boot.nil;
if(!("nilAsValue" in $boot))$boot.nilAsValue=$boot.nilAsReceiver;
var $core=$boot.api,nil=$boot.nilAsValue,$nil=$boot.nilAsReceiver,$recv=$boot.asReceiver,$globals=$boot.globals;
if(!$boot.nilAsClass)$boot.nilAsClass=$boot.dnu;
$core.addPackage("Trapped-Counter");
$core.packages["Trapped-Counter"].innerEval = function (expr) { return eval(expr); };
$core.packages["Trapped-Counter"].imports = ["trapped/Trapped-Processors"];
$core.packages["Trapped-Counter"].transport = {"type":"amd","amdNamespace":"trapped-counter"};

$core.addClass("TrappedCounter", $globals.Object, ["value"], "Trapped-Counter");
$core.addMethod(
$core.method({
selector: "decrement",
protocol: "action",
fn: function (){
var self=this,$self=this;
//>>excludeStart("ctx", pragmas.excludeDebugContexts);
return $core.withContext(function($ctx1) {
//>>excludeEnd("ctx");
$self["@value"]=$recv($self["@value"]).__minus((1));
return self;
//>>excludeStart("ctx", pragmas.excludeDebugContexts);
}, function($ctx1) {$ctx1.fill(self,"decrement",{},$globals.TrappedCounter)});
//>>excludeEnd("ctx");
},
//>>excludeStart("ide", pragmas.excludeIdeData);
args: [],
source: "decrement\x0a\x09value := value - 1",
referencedClasses: [],
//>>excludeEnd("ide");
messageSends: ["-"]
}),
$globals.TrappedCounter);

$core.addMethod(
$core.method({
selector: "increment",
protocol: "action",
fn: function (){
var self=this,$self=this;
//>>excludeStart("ctx", pragmas.excludeDebugContexts);
return $core.withContext(function($ctx1) {
//>>excludeEnd("ctx");
$self["@value"]=$recv($self["@value"]).__plus((1));
return self;
//>>excludeStart("ctx", pragmas.excludeDebugContexts);
}, function($ctx1) {$ctx1.fill(self,"increment",{},$globals.TrappedCounter)});
//>>excludeEnd("ctx");
},
//>>excludeStart("ide", pragmas.excludeIdeData);
args: [],
source: "increment\x0a\x09value := value + 1",
referencedClasses: [],
//>>excludeEnd("ide");
messageSends: ["+"]
}),
$globals.TrappedCounter);

$core.addMethod(
$core.method({
selector: "initialize",
protocol: "initialization",
fn: function (){
var self=this,$self=this;
//>>excludeStart("ctx", pragmas.excludeDebugContexts);
return $core.withContext(function($ctx1) {
//>>excludeEnd("ctx");
(
//>>excludeStart("ctx", pragmas.excludeDebugContexts);
$ctx1.supercall = true,
//>>excludeEnd("ctx");
($globals.TrappedCounter.superclass||$boot.nilAsClass).fn.prototype._initialize.apply($self, []));
//>>excludeStart("ctx", pragmas.excludeDebugContexts);
$ctx1.supercall = false;
//>>excludeEnd("ctx");;
$recv($recv($globals.SimpleAxon)._new())._registerIn_(self);
$self["@value"]=(0);
return self;
//>>excludeStart("ctx", pragmas.excludeDebugContexts);
}, function($ctx1) {$ctx1.fill(self,"initialize",{},$globals.TrappedCounter)});
//>>excludeEnd("ctx");
},
//>>excludeStart("ide", pragmas.excludeIdeData);
args: [],
source: "initialize\x0a\x09super initialize.\x0a\x09SimpleAxon new registerIn: self.\x0a\x09value := 0",
referencedClasses: ["SimpleAxon"],
//>>excludeEnd("ide");
messageSends: ["initialize", "registerIn:", "new"]
}),
$globals.TrappedCounter);

$core.addMethod(
$core.method({
selector: "value",
protocol: "accessing",
fn: function (){
var self=this,$self=this;
return $self["@value"];

},
//>>excludeStart("ide", pragmas.excludeIdeData);
args: [],
source: "value\x0a\x09^value",
referencedClasses: [],
//>>excludeEnd("ide");
messageSends: []
}),
$globals.TrappedCounter);

$core.addMethod(
$core.method({
selector: "value:",
protocol: "accessing",
fn: function (aNumber){
var self=this,$self=this;
$self["@value"]=aNumber;
return self;

},
//>>excludeStart("ide", pragmas.excludeIdeData);
args: ["aNumber"],
source: "value: aNumber\x0a\x09value := aNumber",
referencedClasses: [],
//>>excludeEnd("ide");
messageSends: []
}),
$globals.TrappedCounter);


});
